'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var BreakStatement = (function (_Statement) {
    _inherits(BreakStatement, _Statement);

    // TODO: Requires a loop.
    // TODO: In case of a label, requires label.

    function BreakStatement(childNodes) {
        _classCallCheck(this, BreakStatement);

        _get(Object.getPrototypeOf(BreakStatement.prototype), 'constructor', this).call(this, 'BreakStatement', childNodes);
    }

    _createClass(BreakStatement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'break');

            var label = null;
            if (!children.isEnd) {
                children.skipSameLineNonCode();

                if (children.isNode('Identifier')) {
                    label = children.passNode('Identifier');
                    children.skipNonCode();
                    children.skipSemicolon();
                } else if (children.isToken('Punctuator', ';')) {
                    children.passToken();
                } else {
                    children.passToken();
                    children.skipSemicolon();
                }
            }

            children.assertEnd();

            this._label = label;
        }
    }, {
        key: 'label',
        get: function get() {
            return this._label;
        }
    }]);

    return BreakStatement;
})(_Statement3['default']);

exports['default'] = BreakStatement;
module.exports = exports['default'];