'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _ModuleSpecifier2 = require('../ModuleSpecifier');

var _ModuleSpecifier3 = _interopRequireDefault(_ModuleSpecifier2);

// tests are in ExportNamedDeclaration

var ExportSpecifier = (function (_ModuleSpecifier) {
    _inherits(ExportSpecifier, _ModuleSpecifier);

    function ExportSpecifier(childNodes) {
        _classCallCheck(this, ExportSpecifier);

        _get(Object.getPrototypeOf(ExportSpecifier.prototype), 'constructor', this).call(this, 'ExportSpecifier', childNodes);
    }

    _createClass(ExportSpecifier, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var local = undefined;
            var exported = undefined;

            if (children.isNode('Identifier')) {
                local = children.passNode();
                exported = local;
            } else {
                local = children.passToken();
                if (!local.name && local.value) {
                    local.name = local.value;
                }
            }

            children.skipNonCode();

            if (!children.isEnd) {
                children.passToken('Identifier', 'as');
                children.skipNonCode();
                exported = children.passNode('Identifier');
            }

            children.assertEnd();

            this._local = local;
            this._exported = exported;
        }
    }, {
        key: 'exported',
        get: function get() {
            return this._exported;
        }
    }]);

    return ExportSpecifier;
})(_ModuleSpecifier3['default']);

exports['default'] = ExportSpecifier;
module.exports = exports['default'];