'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var _utilsGetFunctionParams = require('./utils/getFunctionParams');

var _utilsGetFunctionParams2 = _interopRequireDefault(_utilsGetFunctionParams);

var FunctionDeclaration = (function (_Statement) {
    _inherits(FunctionDeclaration, _Statement);

    function FunctionDeclaration(childNodes) {
        _classCallCheck(this, FunctionDeclaration);

        _get(Object.getPrototypeOf(FunctionDeclaration.prototype), 'constructor', this).call(this, 'FunctionDeclaration', childNodes);
    }

    _createClass(FunctionDeclaration, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var params = [];
            var async = false;

            if (children.isToken('Identifier', 'async')) {
                async = true;
                children.passToken('Identifier', 'async');
                children.skipNonCode();
            }

            children.passToken('Keyword', 'function');
            children.skipNonCode();

            var generator = false;
            if (children.isToken('Punctuator', '*')) {
                generator = true;
                children.moveNext();
                children.skipNonCode();
            }

            var id = children.passNode('Identifier');
            children.skipNonCode();

            params = (0, _utilsGetFunctionParams2['default'])(children);
            children.skipNonCode();

            var body = children.passStatement();

            children.assertEnd();

            this._async = async;
            this._id = id;
            this._params = params;
            this._body = body;
            this._generator = generator;
        }
    }, {
        key: 'async',
        get: function get() {
            return this._async;
        }
    }, {
        key: 'params',
        get: function get() {
            return this._params.concat();
        }
    }, {
        key: 'body',
        get: function get() {
            return this._body;
        }
    }, {
        key: 'expression',
        get: function get() {
            return false;
        }
    }, {
        key: 'id',
        get: function get() {
            return this._id;
        }
    }, {
        key: 'generator',
        get: function get() {
            return this._generator;
        }
    }]);

    return FunctionDeclaration;
})(_Statement3['default']);

exports['default'] = FunctionDeclaration;
module.exports = exports['default'];