'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

// TODO: create JSXBoundaryElement?

var JSXClosingElement = (function (_Node) {
    _inherits(JSXClosingElement, _Node);

    function JSXClosingElement(childNodes) {
        _classCallCheck(this, JSXClosingElement);

        _get(Object.getPrototypeOf(JSXClosingElement.prototype), 'constructor', this).call(this, 'JSXClosingElement', childNodes);
    }

    _createClass(JSXClosingElement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Punctuator', '<');
            children.skipNonCode();
            children.passToken('Punctuator', '/');
            children.skipNonCode();
            var name = children.passOneOfNode(['JSXIdentifier', 'JSXMemberExpression', 'JSXNamespacedName']);
            children.skipNonCode();
            children.passToken('Punctuator', '>');
            children.assertEnd();

            this._name = name;
        }
    }, {
        key: 'name',
        get: function get() {
            return this._name;
        }
    }]);

    return JSXClosingElement;
})(_Node3['default']);

exports['default'] = JSXClosingElement;
module.exports = exports['default'];