'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var JSXElement = (function (_Expression) {
    _inherits(JSXElement, _Expression);

    function JSXElement(childNodes) {
        _classCallCheck(this, JSXElement);

        _get(Object.getPrototypeOf(JSXElement.prototype), 'constructor', this).call(this, 'JSXElement', childNodes);
    }

    _createClass(JSXElement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var closingElement = null;
            var childrenProperty = [];

            var openingElement = children.passNode('JSXOpeningElement');
            if (!openingElement.selfClosing) {
                children.skipNonCode();
                while (!children.isNode('JSXClosingElement')) {
                    childrenProperty.push(children.passOneOfNode(['Literal', 'JSXExpressionContainer', 'JSXElement']));
                }
                children.skipNonCode();
                if (children.isNode('JSXClosingElement')) {
                    closingElement = children.passNode('JSXClosingElement');
                }
            }
            children.assertEnd();

            this._children = childrenProperty;
            this._closingElement = closingElement;
            this._openingElement = openingElement;
        }
    }, {
        key: 'children',
        get: function get() {
            return this._children;
        }
    }, {
        key: 'closingElement',
        get: function get() {
            return this._closingElement;
        }
    }, {
        key: 'openingElement',
        get: function get() {
            return this._openingElement;
        }
    }]);

    return JSXElement;
})(_Expression3['default']);

exports['default'] = JSXElement;
module.exports = exports['default'];