'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var updateOperators = {
    '++': true,
    '--': true
};

var UpdateExpression = (function (_Expression) {
    _inherits(UpdateExpression, _Expression);

    // TODO: Should respect operator precedence: putting "++a" after "b" without parens should raise an error.

    function UpdateExpression(childNodes) {
        _classCallCheck(this, UpdateExpression);

        _get(Object.getPrototypeOf(UpdateExpression.prototype), 'constructor', this).call(this, 'UpdateExpression', childNodes);
    }

    _createClass(UpdateExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var operator = undefined;
            var argument = undefined;
            var prefix = undefined;

            if (children.isToken('Punctuator', updateOperators)) {
                operator = children.passToken().value;
                children.skipNonCode();
                argument = children.passAssignable();
                prefix = true;
            } else {
                argument = children.passAssignable();
                children.skipNonCode();
                operator = children.passToken().value;
                prefix = false;
            }

            children.assertEnd();

            this._argument = argument;
            this._operator = operator;
            this._prefix = prefix;
        }
    }, {
        key: 'argument',
        get: function get() {
            return this._argument;
        }
    }, {
        key: 'operator',
        get: function get() {
            return this._operator;
        }
    }, {
        key: 'prefix',
        get: function get() {
            return this._prefix;
        }
    }]);

    return UpdateExpression;
})(_Expression3['default']);

exports['default'] = UpdateExpression;
module.exports = exports['default'];