'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var Reference = (function () {
    function Reference(_ref) {
        var node = _ref.node;
        var scope = _ref.scope;
        var read = _ref.read;
        var write = _ref.write;
        var type = _ref.type;
        return (function () {
            _classCallCheck(this, Reference);

            this._node = node;
            this._scope = scope;
            this._read = read;
            this._write = write;
            this._type = type;
        }).apply(this, arguments);
    }

    _createClass(Reference, [{
        key: 'node',
        get: function get() {
            return this._node;
        }
    }, {
        key: 'scope',
        get: function get() {
            return this._scope;
        }
    }, {
        key: 'variable',
        get: function get() {
            return this._variable;
        }
    }, {
        key: 'isRead',
        get: function get() {
            return this._read;
        }
    }, {
        key: 'isWrite',
        get: function get() {
            return this._write;
        }
    }, {
        key: 'isReadOnly',
        get: function get() {
            return this._read && !this._write;
        }
    }, {
        key: 'isWriteOnly',
        get: function get() {
            return !this._read && this._write;
        }
    }, {
        key: 'isReadWrite',
        get: function get() {
            return this._read && this._write;
        }
    }]);

    return Reference;
})();

exports['default'] = Reference;
module.exports = exports['default'];