'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

/**
 * @name types.ArrayExpression
 */

var ArrayExpression = (function (_Expression) {
    _inherits(ArrayExpression, _Expression);

    function ArrayExpression(childNodes) {
        _classCallCheck(this, ArrayExpression);

        _get(Object.getPrototypeOf(ArrayExpression.prototype), 'constructor', this).call(this, 'ArrayExpression', childNodes);
    }

    _createClass(ArrayExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var elements = [];
            children.passToken('Punctuator', '[');
            children.skipNonCode();
            while (!children.isToken('Punctuator', ']')) {
                if (children.isToken('Punctuator', ',')) {
                    elements.push(null);
                    children.moveNext();
                    children.skipNonCode();
                } else {
                    elements.push(children.passExpressionOrSpreadElement());
                    children.skipNonCode();
                    if (children.isToken('Punctuator', ',')) {
                        children.moveNext();
                        children.skipNonCode();
                    }
                }
            }
            children.passToken('Punctuator', ']');
            children.assertEnd();
            this._elements = elements;
        }
    }, {
        key: 'elements',
        get: function get() {
            return this._elements.concat();
        }
    }]);

    return ArrayExpression;
})(_Expression3['default']);

exports['default'] = ArrayExpression;
module.exports = exports['default'];