'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var assignmentOperators = {
    '=': true,
    '+=': true,
    '-=': true,
    '*=': true,
    '/=': true,
    '%=': true,
    '<<=': true,
    '>>=': true,
    '>>>=': true,
    '|=': true,
    '^=': true,
    '&=': true,
    '**=': true
};

var AssignmentExpression = (function (_Expression) {
    _inherits(AssignmentExpression, _Expression);

    function AssignmentExpression(childNodes) {
        _classCallCheck(this, AssignmentExpression);

        _get(Object.getPrototypeOf(AssignmentExpression.prototype), 'constructor', this).call(this, 'AssignmentExpression', childNodes);
    }

    _createClass(AssignmentExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var left = children.passAssignable();
            children.skipNonCode();
            children.assertToken('Punctuator', assignmentOperators);
            var operator = children.currentElement.value;
            children.moveNext();
            children.skipNonCode();
            var right = children.passExpression();
            children.assertEnd();

            this._left = left;
            this._operator = operator;
            this._right = right;
        }
    }, {
        key: 'left',
        get: function get() {
            return this._left;
        }
    }, {
        key: 'right',
        get: function get() {
            return this._right;
        }
    }, {
        key: 'operator',
        get: function get() {
            return this._operator;
        }
    }]);

    return AssignmentExpression;
})(_Expression3['default']);

exports['default'] = AssignmentExpression;
module.exports = exports['default'];