'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

var CatchClause = (function (_Node) {
    _inherits(CatchClause, _Node);

    function CatchClause(childNodes) {
        _classCallCheck(this, CatchClause);

        _get(Object.getPrototypeOf(CatchClause.prototype), 'constructor', this).call(this, 'CatchClause', childNodes);
    }

    _createClass(CatchClause, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'catch');
            children.skipNonCode();

            children.passToken('Punctuator', '(');
            children.skipNonCode();

            var param = children.passPattern();
            children.skipNonCode();

            children.passToken('Punctuator', ')');
            children.skipNonCode();

            var body = children.passStatement('BlockStatement');
            children.assertEnd();

            this._param = param;
            this._body = body;
        }
    }, {
        key: 'body',
        get: function get() {
            return this._body;
        }
    }, {
        key: 'param',
        get: function get() {
            return this._param;
        }
    }]);

    return CatchClause;
})(_Node3['default']);

exports['default'] = CatchClause;
module.exports = exports['default'];