'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var ClassExpression = (function (_Expression) {
    _inherits(ClassExpression, _Expression);

    function ClassExpression(childNodes) {
        _classCallCheck(this, ClassExpression);

        _get(Object.getPrototypeOf(ClassExpression.prototype), 'constructor', this).call(this, 'ClassExpression', childNodes);
    }

    _createClass(ClassExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'class');
            children.skipNonCode();

            var id = null;
            if (!children.isToken('Keyword', 'extends') && !children.isNode('ClassBody')) {
                id = children.passNode('Identifier');
                children.skipNonCode();
            }

            var superClass = null;
            if (children.isToken('Keyword', 'extends')) {
                children.passToken('Keyword', 'extends');
                children.skipNonCode();
                superClass = children.passExpression();
                children.skipNonCode();
            }

            var body = children.passNode('ClassBody');
            children.assertEnd();

            this._id = id;
            this._superClass = superClass;
            this._body = body;
        }
    }, {
        key: 'id',
        get: function get() {
            return this._id;
        }
    }, {
        key: 'superClass',
        get: function get() {
            return this._superClass;
        }
    }, {
        key: 'body',
        get: function get() {
            return this._body;
        }
    }]);

    return ClassExpression;
})(_Expression3['default']);

exports['default'] = ClassExpression;
module.exports = exports['default'];