'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var ConditionalExpression = (function (_Expression) {
    _inherits(ConditionalExpression, _Expression);

    // TODO: Should respect operator precedence: putting "a + b" before " * b" without parens should raise an error.

    function ConditionalExpression(childNodes) {
        _classCallCheck(this, ConditionalExpression);

        _get(Object.getPrototypeOf(ConditionalExpression.prototype), 'constructor', this).call(this, 'ConditionalExpression', childNodes);
    }

    _createClass(ConditionalExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var test = children.passExpression();
            children.skipNonCode();

            children.passToken('Punctuator', '?');
            children.skipNonCode();

            var consequent = children.passExpression();
            children.skipNonCode();

            children.passToken('Punctuator', ':');
            children.skipNonCode();

            var alternate = children.passExpression();
            children.assertEnd();

            this._test = test;
            this._consequent = consequent;
            this._alternate = alternate;
        }
    }, {
        key: 'test',
        get: function get() {
            return this._test;
        }
    }, {
        key: 'consequent',
        get: function get() {
            return this._consequent;
        }
    }, {
        key: 'alternate',
        get: function get() {
            return this._alternate;
        }
    }]);

    return ConditionalExpression;
})(_Expression3['default']);

exports['default'] = ConditionalExpression;
module.exports = exports['default'];