'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var IfStatement = (function (_Statement) {
    _inherits(IfStatement, _Statement);

    function IfStatement(childNodes) {
        _classCallCheck(this, IfStatement);

        _get(Object.getPrototypeOf(IfStatement.prototype), 'constructor', this).call(this, 'IfStatement', childNodes);
    }

    _createClass(IfStatement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'if');
            children.skipNonCode();

            children.passToken('Punctuator', '(');
            children.skipNonCode();

            var test = children.passExpression();
            children.skipNonCode();

            children.passToken('Punctuator', ')');
            children.skipNonCode();

            var consequent = children.passStatement();

            children.skipNonCode();

            var alternate = null;
            if (children.isToken('Keyword', 'else')) {
                children.moveNext();
                children.skipNonCode();
                alternate = children.passStatement();
            }

            children.assertEnd();

            this._test = test;
            this._consequent = consequent;
            this._alternate = alternate;
        }
    }, {
        key: 'test',
        get: function get() {
            return this._test;
        }
    }, {
        key: 'consequent',
        get: function get() {
            return this._consequent;
        }
    }, {
        key: 'alternate',
        get: function get() {
            return this._alternate;
        }
    }]);

    return IfStatement;
})(_Statement3['default']);

exports['default'] = IfStatement;
module.exports = exports['default'];