'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _ModuleDeclaration2 = require('../ModuleDeclaration');

var _ModuleDeclaration3 = _interopRequireDefault(_ModuleDeclaration2);

var ImportDeclaration = (function (_ModuleDeclaration) {
    _inherits(ImportDeclaration, _ModuleDeclaration);

    function ImportDeclaration(childNodes) {
        _classCallCheck(this, ImportDeclaration);

        _get(Object.getPrototypeOf(ImportDeclaration.prototype), 'constructor', this).call(this, 'ImportDeclaration', childNodes);
    }

    _createClass(ImportDeclaration, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'import');
            children.skipNonCode();

            var specifiers = [];
            var source = null;

            if (children.isNode('ImportDefaultSpecifier')) {
                specifiers.push(children.passModuleSpecifier());
                children.skipNonCode();
                if (children.isToken('Punctuator', ',')) {
                    children.moveNext();
                    children.skipNonCode();
                }
            } else if (children.isNode('ImportNamespaceSpecifier')) {
                specifiers.push(children.passModuleSpecifier());
                children.skipNonCode();
            }

            if (children.isToken('Punctuator', '{')) {
                children.passToken('Punctuator', '{');
                children.skipNonCode();
                while (!children.isToken('Punctuator', '}')) {
                    specifiers.push(children.passModuleSpecifier());
                    children.skipNonCode();
                    if (children.isToken('Punctuator', ',')) {
                        children.moveNext();
                        children.skipNonCode();
                    }
                }
                children.passToken('Punctuator', '}');
                children.skipNonCode();
            }

            if (children.isToken('Identifier', 'from')) {
                children.passToken('Identifier', 'from');
                children.skipNonCode();
            }

            source = children.passNode('Literal');
            if (!children.isEnd) {
                children.skipNonCode();
                children.passToken('Punctuator', ';');
            }

            children.assertEnd();

            this._specifiers = specifiers;
            this._source = source;
        }
    }, {
        key: 'specifiers',
        get: function get() {
            return this._specifiers;
        }
    }, {
        key: 'source',
        get: function get() {
            return this._source;
        }
    }]);

    return ImportDeclaration;
})(_ModuleDeclaration3['default']);

exports['default'] = ImportDeclaration;
module.exports = exports['default'];