'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

var ObjectPattern = (function (_Node) {
    _inherits(ObjectPattern, _Node);

    function ObjectPattern(childNodes) {
        _classCallCheck(this, ObjectPattern);

        _get(Object.getPrototypeOf(ObjectPattern.prototype), 'constructor', this).call(this, 'ObjectPattern', childNodes);
    }

    _createClass(ObjectPattern, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var properties = [];
            children.passToken('Punctuator', '{');
            children.skipNonCode();
            while (!children.isToken('Punctuator', '}')) {
                if (children.isToken('Punctuator', ',')) {
                    children.moveNext();
                    children.skipNonCode();
                    children.assertToken('Punctuator', '}');
                } else {
                    if (children.isNode('SpreadProperty')) {
                        properties.push(children.passNode('SpreadProperty'));
                    } else {
                        properties.push(children.passNode('Property'));
                    }
                    children.skipNonCode();
                    if (children.isToken('Punctuator', ',')) {
                        children.moveNext();
                        children.skipNonCode();
                    }
                }
            }
            children.passToken('Punctuator', '}');
            children.assertEnd();
            this._properties = properties;
        }
    }, {
        key: 'properties',
        get: function get() {
            return this._properties.concat();
        }
    }, {
        key: 'isPattern',
        get: function get() {
            return true;
        }
    }, {
        key: 'isAssignable',
        get: function get() {
            return true;
        }
    }]);

    return ObjectPattern;
})(_Node3['default']);

exports['default'] = ObjectPattern;
module.exports = exports['default'];