'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

var SwitchCase = (function (_Node) {
    _inherits(SwitchCase, _Node);

    function SwitchCase(childNodes) {
        _classCallCheck(this, SwitchCase);

        _get(Object.getPrototypeOf(SwitchCase.prototype), 'constructor', this).call(this, 'SwitchCase', childNodes);
    }

    _createClass(SwitchCase, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var test = null;

            if (children.isToken('Keyword', 'case')) {
                children.passToken();
                children.skipNonCode();

                test = children.passExpression();
                children.skipNonCode();
            } else {
                children.passToken('Keyword', 'default');
                children.skipNonCode();
            }

            children.passToken('Punctuator', ':');
            children.skipNonCode();

            var consequent = [];

            while (!children.isEnd) {
                consequent.push(children.passStatement());
                children.skipNonCode();
            }

            children.assertEnd();

            this._test = test;
            this._consequent = consequent;
        }
    }, {
        key: 'test',
        get: function get() {
            return this._test;
        }
    }, {
        key: 'consequent',
        get: function get() {
            return this._consequent.concat();
        }
    }]);

    return SwitchCase;
})(_Node3['default']);

exports['default'] = SwitchCase;
module.exports = exports['default'];