'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var SwitchStatement = (function (_Statement) {
    _inherits(SwitchStatement, _Statement);

    function SwitchStatement(childNodes) {
        _classCallCheck(this, SwitchStatement);

        _get(Object.getPrototypeOf(SwitchStatement.prototype), 'constructor', this).call(this, 'SwitchStatement', childNodes);
    }

    _createClass(SwitchStatement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'switch');
            children.skipNonCode();

            children.passToken('Punctuator', '(');
            children.skipNonCode();

            var discriminant = children.passExpression();
            children.skipNonCode();

            children.passToken('Punctuator', ')');
            children.skipNonCode();

            children.passToken('Punctuator', '{');
            children.skipNonCode();

            var cases = [];
            while (!children.isToken('Punctuator', '}')) {
                cases.push(children.passNode('SwitchCase'));
                children.skipNonCode();
            }

            children.passToken('Punctuator', '}');
            children.assertEnd();

            this._discriminant = discriminant;
            this._cases = cases;
        }
    }, {
        key: 'discriminant',
        get: function get() {
            return this._discriminant;
        }
    }, {
        key: 'cases',
        get: function get() {
            return this._cases.concat();
        }
    }]);

    return SwitchStatement;
})(_Statement3['default']);

exports['default'] = SwitchStatement;
module.exports = exports['default'];