'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var TemplateLiteral = (function (_Expression) {
    _inherits(TemplateLiteral, _Expression);

    function TemplateLiteral(childNodes) {
        _classCallCheck(this, TemplateLiteral);

        _get(Object.getPrototypeOf(TemplateLiteral.prototype), 'constructor', this).call(this, 'TemplateLiteral', childNodes);
    }

    _createClass(TemplateLiteral, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var quasis = [];
            var expressions = [];

            children.passToken('Punctuator', '`');
            while (!children.isToken('Punctuator', '`')) {
                if (children.isNode('TemplateElement')) {
                    quasis.push(children.passNode('TemplateElement'));
                } else {
                    children.passToken('Punctuator', '${');
                    children.skipNonCode();
                    expressions.push(children.passExpression());
                    children.skipNonCode();
                    children.passToken('Punctuator', '}');
                }
            }
            children.passToken('Punctuator', '`');

            if (quasis.length > 0) {
                quasis[quasis.length - 1].tail = true;
            }

            this._quasis = quasis;
            this._expressions = expressions;
        }
    }, {
        key: 'quasis',
        get: function get() {
            return this._quasis;
        }
    }, {
        key: 'expressions',
        get: function get() {
            return this._expressions;
        }
    }]);

    return TemplateLiteral;
})(_Expression3['default']);

exports['default'] = TemplateLiteral;
module.exports = exports['default'];