'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var WhileStatement = (function (_Statement) {
    _inherits(WhileStatement, _Statement);

    function WhileStatement(childNodes) {
        _classCallCheck(this, WhileStatement);

        _get(Object.getPrototypeOf(WhileStatement.prototype), 'constructor', this).call(this, 'WhileStatement', childNodes);
    }

    _createClass(WhileStatement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'while');
            children.skipNonCode();

            children.passToken('Punctuator', '(');
            children.skipNonCode();

            var test = children.passExpression();
            children.skipNonCode();

            children.passToken('Punctuator', ')');
            children.skipNonCode();

            var body = children.passStatement();

            children.assertEnd();

            this._test = test;
            this._body = body;
        }
    }, {
        key: 'test',
        get: function get() {
            return this._test;
        }
    }, {
        key: 'body',
        get: function get() {
            return this._body;
        }
    }]);

    return WhileStatement;
})(_Statement3['default']);

exports['default'] = WhileStatement;
module.exports = exports['default'];